#! /bin/sh

echo "************************************************************************"
echo "*********************   TASKCTL-KETTLE 插件服务安装      ***************"
echo "*********************   Powered by www.taskctl.com         ***************"
echo "************************************************************************"
chmod -R 755 *
BASE_PATH=$(cd `dirname $0`; pwd)

# 提示输入KETTLE HOME
read -p "请输入kettle安装目录：" KETTLE_HOME
# cp $KETTLE_HOME/lib/. $BASE_PATH/lib -R 

# simple-jndi路径
#if [ -d "$KETTLE_HOME/simple-jndi" ]; then
#	cp $KETTLE_HOME/simple-jndi $BASE_PATH/. -R
#fi

# 提示输入kettle版本号
# read -p "请输入kettle版本号[4/5/6/7(默认)]：" KETTLE_VERSION
# if [ -z "$KETTLE_VERSION" ];then
#	KETTLE_VERSION=7
# fi
# cp $BASE_PATH/lib/v$KETTLE_VERSION/plugin-kettle-0.0.1-SNAPSHOT.jar $BASE_PATH/lib/. -f

# if [[ "$KETTLE_VERSION" = "4" ]];then
# 适配 kettle 4
#if [ -d "$KETTLE_HOME/libext" ];then
#	cp $BASE_PATH/lib/forkettle4/plugin-kettle-0.0.1-SNAPSHOT.jar $BASE_PATH/lib/. -f
#	find $KETTLE_HOME/lib -type f -name "*.jar" | while read src;do
#		cp ${src} $BASE_PATH/lib/. -f
#	done
#fi

PROFILE_TMP_FILE=$BASE_PATH/tmp/ctlconf.tmp
if [ -f "$PROFILE_TMP_FILE" ];then
 rm $PROFILE_TMP_FILE
fi

# 提示输入SOAP地址
DEFAULT_IP=`ifconfig | grep 'inet'| grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $2}'`
read -p "请输入本机网络IP(默认为$DEFAULT_IP)：" SOAP_IP
if [ -z "$SOAP_IP" ];then
	SOAP_IP=$DEFAULT_IP
fi
echo -e "本机网络IP：\t$SOAP_IP" >> $PROFILE_TMP_FILE

read -p "请输入服务端口(默认为8099)：" SOAP_PORT
if [ -z "$SOAP_PORT" ];then
	SOAP_PORT=8099
fi
echo -e "服务端口：\t$SOAP_PORT" >> $PROFILE_TMP_FILE

read -p "请选择资源库类型 [DB(数据库)/FILE(文件库)/NONE(不设置)]：" REPOSITORY_TYPE
if [[ "$REPOSITORY_TYPE" = "DB" ]];then
	REPOSITORY_TYPE=DB
	echo -e "资源库类型：\t$REPOSITORY_TYPE" >> $PROFILE_TMP_FILE
	
	read -p "请输入资源库名：" REPOSITORY_NAME
	echo -e "资源库名：\t$REPOSITORY_NAME" >> $PROFILE_TMP_FILE
	
	read -p "请输入资源库用户名：" REPOSITORY_USER
	echo -e "资源库用户名：\t$REPOSITORY_USER" >> $PROFILE_TMP_FILE
	
	read -p "请输入资源库密码：" REPOSITORY_PWD
	echo -e "资源库密码：\t$REPOSITORY_PWD" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库类型 [Mysql/Oracle/SQL Server ...]：" REPOSITORY_DB_TYPE
	echo -e "数据库类型：\t$REPOSITORY_DB_TYPE" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库连接方式 [Native(默认)/ODBC/JNDI]：" REPOSITORY_DB_ACCESS
	if [ -z "$REPOSITORY_DB_ACCESS" ];then
		REPOSITORY_DB_ACCESS=Native
	fi
	echo -e "数据库连接方式：\t$REPOSITORY_DB_ACCESS" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库服务HOST：" REPOSITORY_DB_HOST
	echo -e "数据库服务HOST：\t$REPOSITORY_DB_HOST" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库服务监听端口：" REPOSITORY_DB_PORT
	echo -e "数据库服务监听端口：\t$REPOSITORY_DB_PORT" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库实例名：" REPOSITORY_DB_NAME
	echo -e "数据库实例名：\t$REPOSITORY_DB_NAME" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库用户名：" REPOSITORY_DB_USER
	echo -e "数据库用户名：\t$REPOSITORY_DB_USER" >> $PROFILE_TMP_FILE
	
	read -p "请输入数据库密码：" REPOSITORY_DB_PWD
	echo -e "数据库密码：\t$REPOSITORY_DB_PWD" >> $PROFILE_TMP_FILE
elif [[ "$REPOSITORY_TYPE" = "FILE" ]];then
	REPOSITORY_TYPE=FILE
	echo -e "资源库类型：\t$REPOSITORY_TYPE" >> $PROFILE_TMP_FILE
	
	read -p "请输入资源库名：" REPOSITORY_NAME
	echo -e "资源库名：\t$REPOSITORY_NAME" >> $PROFILE_TMP_FILE
	
	read -p "请输入文件资源库根目录：" REPOSITORY_FILE_ROOT
	echo -e "文件资源库根目录：\t$REPOSITORY_FILE_ROOT" >> $PROFILE_TMP_FILE
else
	REPOSITORY_TYPE=NONE
	echo -e "资源库类型：\t$REPOSITORY_TYPE" >> $PROFILE_TMP_FILE
fi


echo 请确认以下信息：

echo "************************************************************************"
echo -e "\n"
cat $PROFILE_TMP_FILE
echo -e "\n"
echo "************************************************************************"

read -p "是否确定 [Y/n]：" ISCONFIRM
echo 
if [ `expr match $ISCONFIRM "[Y|y]"` -ne 0 ];then
	# 写配置文件
	PROFILE_FILE=$BASE_PATH/conf/ctlconf.ini
	if [ -f "$PROFILE_FILE" ]; then
	 rm $PROFILE_FILE
	fi
	
 	echo "# plugin config" >> $PROFILE_FILE
	echo "PLUGIN.SOAP_ADDRESS=http://$SOAP_IP:$SOAP_PORT/SoapAPIService" >> $PROFILE_FILE
	echo "PLUGIN.KETTLE.HOME=$KETTLE_HOME" >> $PROFILE_FILE
	echo "PLUGIN.KETTLE.USER=$HOME" >> $PROFILE_FILE	
	echo "PLUGIN.KETTLE.LOGLEVEL=DEBUG" >> $PROFILE_FILE
	
	echo "# repository config"  >> $PROFILE_FILE
	echo "REPOSITORY.TYPE=$REPOSITORY_TYPE" >> $PROFILE_FILE
	echo "REPOSITORY.NAME=$REPOSITORY_NAME" >> $PROFILE_FILE
	echo "REPOSITORY.USER=$REPOSITORY_USER" >> $PROFILE_FILE
	echo "REPOSITORY.PWD=$REPOSITORY_PWD" >> $PROFILE_FILE
	
	echo "# database repository config" >> $PROFILE_FILE
	echo "REPOSITORY.DB.TYPE=$REPOSITORY_DB_TYPE" >> $PROFILE_FILE
	echo "REPOSITORY.DB.ACCESS=$REPOSITORY_DB_ACCESS" >> $PROFILE_FILE
	echo "REPOSITORY.DB.HOST=$REPOSITORY_DB_HOST" >> $PROFILE_FILE
	echo "REPOSITORY.DB.PORT=$REPOSITORY_DB_PORT" >> $PROFILE_FILE
	echo "REPOSITORY.DB.NAME=$REPOSITORY_DB_NAME" >> $PROFILE_FILE
	echo "REPOSITORY.DB.USER=$REPOSITORY_DB_USER" >> $PROFILE_FILE
	echo "REPOSITORY.DB.PWD=$REPOSITORY_DB_PWD" >> $PROFILE_FILE

	echo "# file repository config demo" >> $PROFILE_FILE
	echo "REPOSITORY.FILE.ROOT=$REPOSITORY_FILE_ROOT" >> $PROFILE_FILE
	
  	# 生成wrapper启动配置文件
	cp ${BASE_PATH}/bin/wrapper.tmp ${BASE_PATH}/conf/wrapper.conf -rf
	sed -i "s#{KETTLE_HOME}#${KETTLE_HOME}#g" $BASE_PATH/conf/wrapper.conf
	
	# 自动生成 TASKCTL 插件文件	
	cp ${BASE_PATH}/bin/cprunsoapkjb_unix.tmp ${BASE_PATH}/cprunsoapkjb.sh -rf
	sed -i "s#{SOAP_IP}:{SOAP_PORT}#${SOAP_IP}:${SOAP_PORT}#g" $BASE_PATH/cprunsoapkjb.sh
	
	cp ${BASE_PATH}/bin/cprunsoapktr_unix.tmp ${BASE_PATH}/cprunsoapktr.sh -rf
	sed -i "s#{SOAP_IP}:{SOAP_PORT}#${SOAP_IP}:${SOAP_PORT}#g" $BASE_PATH/cprunsoapktr.sh

	cp ${BASE_PATH}/bin/cpstopsoapjob.tmp ${BASE_PATH}/cpstopsoapjob.sh -rf
	sed -i "s#{SOAP_IP}:{SOAP_PORT}#${SOAP_IP}:${SOAP_PORT}#g" $BASE_PATH/cpstopsoapjob.sh	
	
	echo "恭喜您，安装完成！"
	
	echo "************************************************************************"
	echo -e "\n"
	echo "1、请把生成的${BASE_PATH}/cprunsoapktr.sh [kettle 转换插件程序]拷贝至TASKCTL服务端安装目录："
	echo "   $TASKCTLDIR/src/plugin/ktrjob/shell/"
	echo "2、请把生成的${BASE_PATH}/cprunsoapkjb.sh [kettle job插件程序]拷贝至TASKCTL服务端安装目录："
	echo "   $TASKCTLDIR/src/plugin/kjbjob/shell/"
	echo "3、获取教程请关注公众号TASKCTL，回复 3443 或 3444"
	echo "4、若有疑问，请加75273038 [QQ一群]，422877115 [QQ二群]"	
	echo -e "\n"
	echo "************************************************************************"
	
else
	./install.sh
fi


exit 0
